/*****************/
/* D I L E M M A */
/*****************/
/* data 30/11/92, 01/12/92, 13/12/92 */

#include <stdio.h>
#include <graphics.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <process.h>

#define  PROGRAMMA     "DILEMMA.EXE"

#define  SCRLX         640
#define  SCRLY         350
/* haltezza della banda dei pulsanti centrale */
#define  H_BANDA        50
/* ampiezza pulsanti */
#define  AMPIEZX       100
#define  AMPIEZY       H_BANDA - 15

#define  DIMCEL         14

/* livello massimo */
#define  MAXLIV         30
/* costanti per mouse */
#define  INT_MOUSE    0x33
#define  MOUS_RESET      0
#define  MOUS_XY_TAS     3
#define  MOUS_BUTTON     5
#define  MOUS_SETLOC     4
#define  MOUS_RANGEX	 7
#define  MOUS_RANGEY     8
/* costanti per movimento pezzo */
#define  NO_PEZZO       -1
#define  MAX_X_SF       DIMCEL * 5 - 1
#define  MAX_Y_SF       DIMCEL * 5 - 1
/* offset delle scritte */
#define  OF_TXT         7
/* ampiezza in pixel dell' ombra dei pulsanti, grid, pezzo, pezzi in basso, */
#define  AMP_PULS	2
#define  AMP_GRID	2
#define  AMP_PEZZ	2
#define  AMP_PZ12	2
/* larghezza e altezza di un singolo segmento dei Numeri e spessore
   distanza x e y tra segmenti e offset x e y ombra */
#define  NUM_SLX        20
#define  NUM_SHY        10
#define  NUM_SDX         1
#define  NUM_SDY         1
#define  NUM_SOX         3
#define  NUM_SOY         3
/* costanti per setta pagina */
#define  MOUS_PEZZ	 0
#define  MOUS_CURS	 1
/* offset da applicare alla stringa del nome sottrarre */
#define  OFF_NAME      137
/* scritto: Ballabio Alberto */
#define  NAME         ""
/* pulsanti */
#define  XDEC           50
#define  YDEC           (SCRLY - (AMPIEZY)) / 2
#define  XINC           SCRLX - XDEC - AMPIEZX
#define  YINC           (SCRLY - (AMPIEZY)) / 2
#define  XESCI          (SCRLX - AMPIEZX) / 2
#define  YESCI          SCRLY / 2 + 50
#define  XOK            (SCRLX - AMPIEZX) / 2
#define  YOK            SCRLY / 2 - 50 - (AMPIEZY)

/* offset x scritte in default */
#define  OFF_TXT         4

/* PROTOTIPI */
void Inizialize (void);
void Mouse (int  funzione);
void SettaPagina ( void );
void InizializeGrid (int level);
void MuoviPezzo( int liv );
void Bottone(int x, int y, int lx, int ly, int color, int ombra, int ampiezza);
int  ContLim (int x, int y, int cx, int cy);
void Scrivi(int tx, int ty, char *stringa, int color);

/* coordinate massime del pezzo in uso ovvero (mx - my) / 2 */
int plx, ply;
/* offset del pezzo in uso */
int ofx, ofy;
/* necessaria per interrupt mouse definita in dos.h */
struct REGPACK   reg;
/* coordinate puntatore + pulsante mouse */
int x, y, b;
/* pagina visualizza */
int pg = 0;

/* puntatore ad un buffer per lo sfondo sotto il pezzo */
void   *buf_sf;

/* coordinate precedenti del pezzo */
int   cpx = -1, cpy = -1;

main(int argc, char *argv[])
{

  int   liv = 0, vite = 0, tempo = 0;
  int   i, fine = 1;

  char  *s;

  /* controlla se la stringa passata corrisponde a quella in memoria */
  s = NAME;
  while ( *s != '\0' )
    if ( *s++ != *argv[1]++)
       liv = 1;
  if (liv != 1)
  {
    liv = atoi(argv[2]);
    vite = atoi(argv[3]);
    tempo = atoi(argv[4]);
  }

  Inizialize ();

  while (fine)
  {
      Mouse ( MOUS_XY_TAS);
      x = reg.r_cx;
      y = reg.r_dx;
      Mouse ( MOUS_BUTTON );
      b = reg.r_bx;

      /* controlla se e' stato premuto un pulsante */
      if ( b )
      {
	  if (ContLim(x, y, XINC, YINC) && liv < MAXLIV)
	     liv++;
	  if (ContLim(x, y, XDEC, YDEC) && liv > 1)
	     liv--;
	  if (ContLim(x, y, XOK, YOK))
	  {
		 itoa(liv, s, 10);
			printf("by BA");
	     execl(PROGRAMMA, "", NAME, s, NULL);
	  }
	  if (ContLim(x, y, XESCI, YESCI))
	     fine = 0;
      }

      /* ridisegna il pezzo */
      MuoviPezzo(liv);

  }
  textmode(C80);
  exit(0);
}

/* ************************************************************************ */
void Inizialize (void)
{
  int   grph_drv, grph_mode;
  int   i = 0;
  char *s = NAME, *p;

  grph_drv = EGA;
  grph_mode = EGAHI;
  initgraph(&grph_drv, &grph_mode, "");
  setviewport(0, 0, SCRLX - 1, SCRLY - 1, 0);
  cleardevice();

  p = s;
  while (*s != '\0')
    *s++ -= OFF_NAME;
  s = p;

  while (i++ < 2)
  {
    SettaPagina();
    line (0, (SCRLY - H_BANDA) / 2, SCRLX,(SCRLY - H_BANDA) / 2);
    line (0, (SCRLY + H_BANDA) / 2, SCRLX,(SCRLY + H_BANDA) / 2);
    /* colora lo parte superiore di RED */
    setfillstyle( SOLID_FILL, RED);
    bar(0,0, SCRLX -1, (SCRLY - H_BANDA) / 2 - 1);

    /* colora lo parte inferiore di BLUE */
    setfillstyle( SOLID_FILL, BLUE);
    bar(0, (SCRLY + H_BANDA) / 2, SCRLX -1, SCRLY - 1);

    /* colora lo parte centrale di DARKGRAY */
    setfillstyle( SOLID_FILL, DARKGRAY);
    bar(0, (SCRLY - H_BANDA) / 2, SCRLX -1, (SCRLY + H_BANDA) / 2 );

    /* traccia nella parte centrale due linee WHITE */
    setcolor(WHITE);
    line (0, (SCRLY - H_BANDA) / 2, SCRLX,(SCRLY - H_BANDA) / 2);
    line (0, (SCRLY + H_BANDA) / 2, SCRLX,(SCRLY + H_BANDA) / 2);

    settextjustify(CENTER_TEXT, TOP_TEXT);
    settextstyle(DEFAULT_FONT, HORIZ_DIR, 0);

    /* pulsante incrementa */
    Bottone (XINC, YINC, AMPIEZX, AMPIEZY, RED, 1, 3);
    setcolor(WHITE);
    outtextxy (XINC + AMPIEZX / 2, SCRLY / 2 - OFF_TXT, "> > >");

    /* pulsante decrementa */
    Bottone (XDEC, YDEC, AMPIEZX, AMPIEZY, GREEN, 1, 3);
    setcolor(WHITE);
    outtextxy (XDEC + AMPIEZX / 2, SCRLY / 2 - OFF_TXT, "< < <");

    /* pulsante fine */
    Bottone (XESCI, YESCI, AMPIEZX, AMPIEZY, LIGHTBLUE, 1, 3);
    setcolor(WHITE);
    outtextxy (SCRLX / 2, YESCI + (AMPIEZY) / 2 - OFF_TXT, "USCITA");

    /* pulsante OK */
    Bottone (XOK, YOK, AMPIEZX, AMPIEZY, LIGHTRED, 1, 3);
    setcolor(WHITE);
    outtextxy (SCRLX / 2, YOK + (AMPIEZY) / 2 - OFF_TXT, "PARTENZA");

    settextjustify(CENTER_TEXT, TOP_TEXT);
    setcolor(WHITE);
    outtextxy (SCRLX / 2, SCRLY / 2 - OFF_TXT, "Partenza dal livello:   ");

    settextjustify(CENTER_TEXT, BOTTOM_TEXT);
    setcolor(LIGHTCYAN);
    outtextxy (SCRLX / 2, SCRLY - OFF_TXT,
	       "Programmato usando il Turbo C 2.0");

    /* dati miei */
    setcolor(WHITE);
    outtextxy (SCRLX / 2, 20, "by");
    outtextxy (SCRLX / 2, 40, s);
    outtextxy (SCRLX / 2, 60, "Tel. (0362) 523013");

    /* scritte dilemma */
    setcolor(CYAN);
    settextstyle(TRIPLEX_FONT, HORIZ_DIR, 0);
    settextjustify(LEFT_TEXT, TOP_TEXT);
    outtextxy (XDEC - 20, (SCRLY - H_BANDA) / 4 - OFF_TXT * 3, "DILEMMA");
    settextjustify(RIGHT_TEXT, TOP_TEXT);
    outtextxy (XINC + AMPIEZX + 20, (SCRLY - H_BANDA) / 4 - OFF_TXT * 3,
	       "DILEMMA");



  }
  buf_sf = malloc ( imagesize (0, 0, DIMCEL, DIMCEL));
  Mouse( MOUS_RESET );
  reg.r_cx = 0;
  reg.r_dx = SCRLX - DIMCEL - 1;
  Mouse( MOUS_RANGEX );
  reg.r_cx = 0;
  reg.r_dx = SCRLY - DIMCEL - 1;
  Mouse( MOUS_RANGEY );
}

/* ************************************************************************ */
void Mouse (int  funzione)
{
  reg.r_ax = funzione;
  intr(INT_MOUSE, &reg);
}

/* ************************************************************************ */
/* Scambia le 2 pagine video usate - 1 visualizzata e 1 x stampare
   se ms = 1 pagina attiva e visualizzata = pg */
void SettaPagina( void )
{
  setactivepage( pg );
  pg = ~pg & 1;
  setvisualpage( pg );
}

/* ************************************************************************ */
/* controlla limiti dei pulsanti */
int  ContLim (int px, int py, int cx, int cy)
{
  if (px - cx < AMPIEZX && px > cx  && py - cy < AMPIEZY && py > cy )
     return (1);
  else
     return (0);
}
/* ************************************************************************ */
/* scrive un testo con l'ombra nera */
void Scrivi(int tx, int ty, char *stringa, int color)
{
  if (color != GREEN)
    setcolor(BLACK);
  else
    setcolor(GREEN);
  outtextxy(tx + 3, ty + 3, stringa);
  setcolor(color);
  outtextxy(tx, ty, stringa);
}

/* ************************************************************************ */
void MuoviPezzo(int liv)
{

  /* se = 1 nuova posizione pezzo */
  static char *s;
  static tx, ty, pliv = 0;

  tx = x;
  ty = y;

  if (tx != cpx || ty != cpy || pliv != liv)
  {

    itoa(liv, s, 10);
    settextjustify(CENTER_TEXT, TOP_TEXT);
    settextstyle(DEFAULT_FONT, HORIZ_DIR, 0);
    setcolor (DARKGRAY);
    outtextxy (SCRLX / 2 + 90, SCRLY / 2 - OFF_TXT, "");
    setcolor (WHITE);
    outtextxy (SCRLX / 2 + 90, SCRLY / 2 - OFF_TXT, s);

    /* disegna cursore A */
      setcolor(YELLOW);
      line(tx, ty, tx + DIMCEL, ty + DIMCEL);
      line(tx, ty, tx, ty + DIMCEL);
      line(tx, ty + 9, tx + 8, ty + 9);

    SettaPagina();

    if ( cpx != -1 )
      putimage(cpx, cpy, buf_sf, COPY_PUT);

    setcolor (DARKGRAY);
    outtextxy (SCRLX / 2 + 90, SCRLY / 2 - OFF_TXT, "");
    setcolor (WHITE);
    outtextxy (SCRLX / 2 + 90, SCRLY / 2 - OFF_TXT, s);

    getimage(tx, ty, tx + DIMCEL, ty + DIMCEL, buf_sf);

    cpx = tx;
    cpy = ty;
    pliv = liv;
  }
}

/* ************************************************************************ */
void Bottone(int bx, int by, int lx, int ly, int color, int ombra,
	     int ampiezza)
/* stampa un singolo bottone con un colore dato
   bx, by coordinate lx, ly ampiezza del bottone
   ombra pulsante schiacciato o meno 0/1
   ampiezza  dell'ombra */
{
  int i;

 --lx;
 --ly;
 setcolor( color );
 setfillstyle( SOLID_FILL, color);
 bar(bx, by, bx + lx, by + ly);

  if (color > 7)
   color = WHITE;
  else
   color += 8;

 for(i = 0; i < ampiezza; i++)
 {
   setcolor ( ombra == 0 ? BLACK : color );
   line(bx + i, by + ly - 1 - i, bx + i, by + i);
   line(bx + i, by + i, bx + lx - 1 - i, by + i);
   setcolor( ombra == 0 ? color : BLACK);
   line(bx + i, by + ly - i, bx + lx - i, by + ly - i);
   line(bx + lx - i, by + ly - i, bx + lx - i, by + i);
  }
}

